lexer grammar CSimple;
options {
  language=Java;

}
@members {
  private int lineCount = 0;
  
  /**
  * @returns count of all new-lines not in comments
  */
  public int getLineCount() {
    return lineCount;
  }
}
@header {
  package de.sm.csimple;
}

TYPEDEF : 'typedef' ;
STRUCT : 'struct' ;
STATIC : 'static' ;
INLINE : 'inline' ;
EXTERN : 'extern' ;
CONST : 'const' ;
MINUS : '-' ;
ATTR : '__attribute__' ;
HEXPREFIX : '0x' ;
T25 : '[' ;
T26 : ']' ;
T27 : '=' ;
T28 : ';' ;
T29 : '#' ;
T30 : '(' ;
T31 : ')' ;
T32 : '*' ;
T33 : 'a' ;
T34 : 'f' ;
T35 : 'A' ;
T36 : 'F' ;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 198
SPECIAL : '(' | ')' | ':' | '='| '.' | '*' | '+' | '%' | '#' | '/' | '\\' | '^' | '?' | '@' | '$'
	| '_' | ';' | ',' | '|' | '&' | '<' | '>' | '[' | ']' | '!' | '\'' | '~' ;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 201
IDENTIFIER : (LETTER | '_') ( DIGIT | LETTER | '_' )*;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 203
DIGIT
    :    '0'..'9'
    ;
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 206
fragment LETTER
    : 'a'..'z'
    | 'A'..'Z'
    ;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 211
PPCONTINUE: '\\' NEWLINE;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 213
NEWLINE
  : '\r'? '\n'
  { lineCount++; }
  //{ channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 219
WS
  : (' '|'\t')+		//|'\n'|'\r' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 224
COMMENT
  : '//' (~('\n'|'\r'))* NEWLINE
  { channel=HIDDEN; }
;
  
// multiple-line comments
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 230
ML_COMMENT
  : '/*' (options {greedy=false;} : .)* '*/' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 235
QUOTE  : '"';
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 236
LBRACE : '{';
// $ANTLR src "/VMADL.j/src/de/sm/csimple/CSimple.g" 237
RBRACE : '}';