package de.sm.metrics;

import java.io.File;
import java.io.IOException;

import org.antlr.runtime.ANTLRFileStream;
import org.antlr.runtime.CharStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.RecognitionException;

import de.sm.aspectc.AspectCLexer;
import de.sm.aspectc.AspectCParser;
import de.sm.csimple.CSimpleLexer;
import de.sm.csimple.CSimpleParser;
import de.sm.vmadl.CombinationRegistry;
import de.sm.vmadl.ServiceRegistry;
import de.sm.vmadl.VmadlLexer;
import de.sm.vmadl.VmadlParser;
import de.sm.vmadl.VmadlParser.architecture_return;
import de.sm.vmadl.elements.ServiceModule;

public class AspectCMetrics extends Metrics {

	private AspectCParser parser;
	
	public AspectCMetrics(File file) throws IOException, RecognitionException {
		super(file);
		parseFile();
	}
	
	private void parseFile() throws IOException, RecognitionException {
		CharStream input = new ANTLRFileStream(file.getAbsolutePath());
		AspectCLexer lexer = new AspectCLexer(input);
        CommonTokenStream tokens = new  CommonTokenStream(lexer);
        parser = new AspectCParser(tokens);
        parser.setParsedFile(file);
	    parser.aspectDefinition();
	}
	
	public int getAdviceCount() {
		return parser.getAdviceCount();
	}
	
	public int getPointcutCount() {
		return parser.getPointcutCount();
	}
	
}
