package de.sm.metrics;

import java.io.File;

import de.sm.misc.Registry;

public class ModuleRegistry extends Registry<File, Module> {
	
	private File baseDir;
	private ConceptualModule root;
	
	public ModuleRegistry(File base) {
		baseDir = base;
	}
	
	public ConceptualModule getRoot() {
		return root;
	}

	@Override
	protected Module getNewItem(final File id) {
		Module m;
		if (id.isDirectory()) {
			m = new ConceptualModule(id);
		} else {
			m = new ImplementationModule(id);
		}
		
		if (!id.equals(baseDir)) {
			ConceptualModule parent = 
				(ConceptualModule) this.get(id.getParentFile());
			m.setParent(parent);
			parent.addSubModul(m);
			
		} else {
			root = (ConceptualModule) m;
		}
		
		return m;
	}

}
