package de.sm.odl;

import de.sm.misc.Registry;
import de.sm.odl.elements.TempType;
import de.sm.odl.elements.Type;

public class TypeRegistry extends Registry<String, Type> {
	
	public void register(Type type) {
		if (registry.containsKey(type.getName())) {
			Type t = registry.get(type.getName());
			if (!(t instanceof TempType)) {
				throw new IllegalStateException("Type with name "
						+ type.getName() + " has been already registered.");
			}
			TempType temp = (TempType) t;
			temp.initialize(type);
		}
		
		registry.put(type.getName(), type);
	}
	
	@Override
	protected Type getNewItem(final String name) {
		Type t = new TempType();
		t.setName(name);
		return t;
	}
}
