package de.sm.vmadl;

import java.util.ArrayList;
import java.util.Collection;

import de.sm.misc.Registry;
import de.sm.vmadl.elements.Combination;
import de.sm.vmadl.elements.CombinationId;
import de.sm.vmadl.elements.ServiceModule;

public class CombinationRegistry extends Registry<CombinationId, Combination> {

	@Override
	protected Combination getNewItem(CombinationId id) {
		return new Combination(id);
	}

	/**
	 * Figures out the acutally needed combinations by the 
	 * list of active services.
	 * @param services active service modules
	 */
	public Collection<Combination> getActiveCombinations(
			final Collection<ServiceModule> services) {
		Collection<Combination> activeCombs = new ArrayList<Combination>();
		
		for (Combination comb : registry.values()) {
			if (services.contains(comb.id.getModuleA())
					&& services.contains(comb.id.getModuleB())) {
				activeCombs.add(comb);
			}
		}
		return activeCombs;
	}
}
