package de.sm.vmadl;

import de.sm.misc.Registry;
import de.sm.vmadl.elements.QualifiedIdentifier;
import de.sm.vmadl.elements.ServiceModule;

/**
 * Registry for all service modules.
 * If a requested service module is not available a temporary module
 * is created but not initalized.
 * 
 * @author Stefan Marr
 */
public class ServiceRegistry extends Registry<String, ServiceModule> {
	
	@Override
	protected ServiceModule getNewItem(String name) {
		ServiceModule module = new ServiceModule();
		module.name = new QualifiedIdentifier(name);
		return module;
	}

}
