lexer grammar Vmadl;
options {
  language=Java;

}
@header {
  package de.sm.vmadl;
}

SERVICE : 'service' ;
STARTUP : 'startup' ;
SHUTDOWN : 'shutdown' ;
EXPOSE : 'expose' ;
ADVICE : 'advice' ;
POINTCUT : 'pointcut' ;
REQUIRE : 'require' ;
BOOT : 'boot' ;
FOR : 'for' ;
T23 : ';' ;
T24 : '#' ;

// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 154
SERVICE_NAME : LETTER ( DIGIT | LETTER | '-' | '_' )*;

// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 156
DIGIT
    :    '0'..'9'
    ;
// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 159
fragment LETTER
    : 'a'..'z'
    | 'A'..'Z'
    ;

// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 164
SPECIAL : '(' | ')' | ':' | '='| '.' | '*' | '+' | '%' | '#' | '/' | '\\'
	| '_' | ';' | ',' | '|' | '&' | '-' | '"' | '<' | '>' | '[' | ']' | '!' | '\'' ;

// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 167
NEWLINE
  : '\r'? '\n'
  //{ channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 172
WS
  : (' '|'\t')+		//|'\n'|'\r' 
  { channel=HIDDEN; }
;

// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 177
COMMENT
  : '//' (~('\n'|'\r'))* NEWLINE
  { channel=HIDDEN; }
;
  
// multiple-line comments
// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 183
ML_COMMENT
  : '/*' (options {greedy=false;} : .)* '*/' 
  { channel=HIDDEN; }
;

//SEMICOLON : ';';
// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 189
LBRACE : '{';
// $ANTLR src "/VMADL.j/src/de/sm/vmadl/Vmadl.g" 190
RBRACE : '}';
