lexer grammar Vmadl;
options {
  language=Java;

}
@header {
  package de.sm.vmadl;
}

SERVICE : 'service' ;
STARTUP : 'startup' ;
SHUTDOWN : 'shutdown' ;
EXPOSE : 'expose' ;
ADVICE : 'advice' ;
POINTCUT : 'pointcut' ;
REPLACE : 'replace' ;
REQUIRE : 'require' ;
BOOT : 'boot' ;
FOR : 'for' ;
TYPES : 'types' ;
COMBINE : 'combine' ;
STATIC : 'static' ;
EXTERN : 'extern' ;
CONST : 'const' ;
HEXPREFIX : '0x' ;
RESTRICT : 'restrict' ;
T34 : ',' ;
T35 : '[' ;
T36 : ']' ;
T37 : '=' ;
T38 : ';' ;
T39 : '*' ;
T40 : 'a' ;
T41 : 'f' ;
T42 : 'A' ;
T43 : 'F' ;
T44 : '#' ;
T45 : '.' ;

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 278
IDENTIFIER : LETTER ( DIGIT | LETTER | '-' | '_' )*;

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 280
DIGIT
    :    '0'..'9'
    ;
// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 283
fragment LETTER
    : 'a'..'z'
    | 'A'..'Z'
    ;

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 288
LPARENTHESIS: '(';
// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 289
RPARENTHESIS: ')';

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 291
SPECIAL : ':' | '='| '.' | '*' | '+' | '%' | '#' | '/' | '\\'
	| '_' | ';' | ',' | '|' | '&' | '-' | '"' | '<' | '>' | '[' | ']' | '!' | '\'' | '?' ;

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 294
PPCONTINUE: '\\' NEWLINE;

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 296
NEWLINE
  : '\r'? '\n'
  //{ channel=HIDDEN; }
;

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 301
WS
  : (' '|'\t')+		//|'\n'|'\r' 
  { channel=HIDDEN; }
;

// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 306
COMMENT
  : '//' (~('\n'|'\r'))* NEWLINE
  { channel=HIDDEN; }
;
  
// multiple-line comments
// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 312
ML_COMMENT
  : '/*' (options {greedy=false;} : .)* '*/' 
  { channel=HIDDEN; }
;

//SEMICOLON : ';';
// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 318
LBRACE : '{';
// $ANTLR src "\VMADL.j\src\de\sm\vmadl\Vmadl.g" 319
RBRACE : '}';
