package de.sm.vmadl.elements;


public class CombinationId {
	
	private QualifiedIdentifier idA;
	private QualifiedIdentifier idB;
	
	private ServiceModule moduleA;
	private ServiceModule moduleB;
	
	public CombinationId(ServiceModule serviceModuleA,
			ServiceModule serviceModuleB) {
		idA = serviceModuleA.name;
		idB = serviceModuleB.name;
		
		moduleA = serviceModuleA;
		moduleB = serviceModuleB;
	}

	@Override
	public boolean equals(final Object o) {
		if (this == o)
			return true;
		
		if (o instanceof CombinationId) {
			CombinationId qid = (CombinationId) o;
			return (idA == qid.idA && idB == qid.idB)
				|| (idA == qid.idB && idB == qid.idA);
		}
		return false;
	}
	
	/**
	 * Not really sure about how good this implementation is, but is 
	 * independent of the order of the assigned modules.
	 * @return hash code
	 */
	@Override
	public final int hashCode() {
		return idA.hashCode() * idB.hashCode();
	}
	
	public ServiceModule getModuleA() {
		return moduleA;
	}

	public ServiceModule getModuleB() {
		return moduleB;
	}
}
