package de.sm.vmadl.elements;

public class QualifiedIdentifier {
	private String module;
	private String name;
	
	public QualifiedIdentifier(final QualifiedIdentifier module, final String name) {
		this.module = module.getModule();
		this.name = name.intern();
	}
	
	public QualifiedIdentifier(final String module, final String name) {
		this.module = module.intern();
		this.name = name.intern();
	}
	
	public QualifiedIdentifier(final String module) {
		this.module = module.intern();
	}
	
	public final String getModule() {
		return module;
	}
	
	public final String getName() {
		return name;
	}
	
	@Override
	public final String toString() {
		return module + (name == null ? "" : "." + name);
	}
	
	@Override
	public final boolean equals(final Object o) {
		if (this == o) {
			return true;
		}
		
		if (o instanceof QualifiedIdentifier) {
			QualifiedIdentifier qid = (QualifiedIdentifier) o;
			return module == qid.module && name == qid.name;
		}
		return false;
	}
	
	@Override
	public final int hashCode() {
		return module.hashCode() * 55049 + (name == null?0:name.hashCode());
	}
}
