package de.sm.vmadl.elements;

import java.util.ArrayList;
import java.util.List;

public class ServiceInterface {
	
	public ServiceInterface() {
		requirements = new ArrayList<ServiceModule>();
		declarations = new ArrayList<String>();
		advices = new ArrayList<String>();
		pointcuts = new ArrayList<String>();
		
		startupAdvices = new ArrayList<String>();
		startupPointcuts = new ArrayList<String>();
		shutdownAdvices = new ArrayList<String>();
		shutdownPointcuts = new ArrayList<String>();
	}
	
	/**
	 * Raw data strings with includes, global variables and function definitions.
	 * Advices are stored in their own field.
	 */
	public List<String> declarations;
	
	/**
	 * Raw data string with advices from a service.
	 */
	public List<String> advices;
	
	/**
	 * Raw data string with pointcuts exposed by a service.
	 */
	public List<String> pointcuts;
	
	/**
	 * Raw data string with service advices, only active in startup phase. 
	 */
	public List<String> startupAdvices;
	
	/**
	 * Raw data string with service pointcuts, only active in startup phase.
	 */
	public List<String> startupPointcuts;
	
	/**
	 * Raw data string with service advices, only active in shutdown phase. 
	 */
	public List<String> shutdownAdvices;
	
	/**
	 * Raw data string with service pointcuts, only active in shutdown phase.
	 */
	public List<String> shutdownPointcuts;
	
	/**
	 * List of modules this module does require.
	 */
	public List<ServiceModule> requirements;
}
