#ifndef VMMUTEX_H_
#define VMMUTEX_H_

/* Native multi-threading for CSOM - Mutex primitive class
 * 
 * Copyright (C) 2007 by Martin Beck and Jan Klimke
 * 
 * created 2007-05-09
 */

#include <vmobjects/VMObject.h>

#include <pthread.h>

typedef pthread_mutex_t MutexId, *pMutexId;

#pragma mark VTable definition

VTABLE(VMMutex) {
#define VMMUTEX_VTABLE_FORMAT \
    VMOBJECT_VTABLE_FORMAT; \
    pMutexId (*get_embedded_mutex_id)(pVMMutex); \
    void     (*lock)(pVMMutex); \
    void     (*unlock)(pVMMutex); \
    bool     (*is_locked)(pVMMutex)
    
    VMMUTEX_VTABLE_FORMAT;
};

#pragma mark class definition

struct _VMMutex {
    VTABLE(VMMutex) *_vtable;
#define VMMUTEX_FORMAT \
    MutexId embedded_mutex_id
    
    VMMUTEX_FORMAT;
};

#pragma mark class methods

pVMMutex VMMutex_new(void);

#pragma mark vtable initialization

VTABLE(VMMutex) *VMMutex_vtable(void);

#endif /*VMMUTEX_H_*/
