/* 
 * Signal.c
 *  
 * Native multi-threading synchronization for CSOM
 * 
 * by Martin Beck and Jan Klimke
 * 
 * created 2007-06-11
 */

#include "Signal.h"

#include <native/VMSignal.h>

#include <vmobjects/VMObject.h>
#include <vmobjects/VMFrame.h>
#include <vmobjects/VMClass.h>

#include <vm/Universe.h>

extern "C" {

void _Signal_wait(pVMObject object, pVMFrame frame){
	pVMSignal signal = (pVMSignal)SEND(frame, pop);
	SEND(signal, wait);
    SEND(frame, push, (pVMObject)signal);
}

void _Signal_signal(pVMObject object, pVMFrame frame){
	pVMSignal signal = (pVMSignal)SEND(frame, pop);
	SEND(signal, signal);
	SEND(frame, push, (pVMObject)signal);	
}

void _Signal_signalAll(pVMObject object, pVMFrame frame){
	pVMSignal signal = (pVMSignal)SEND(frame, pop);
	pSignalId psid = SEND(signal, get_embedded_signal_id);
    SEND(signal, signal_all);
    SEND(frame, push, (pVMObject)signal);
}

void Signal_new(pVMObject object, pVMFrame frame){
	pVMClass self = (pVMClass) SEND(frame, pop);
	pVMSignal signal = VMSignal_new();
    SEND(frame, push, (pVMObject)signal);
}

}
