#ifndef NATIVE_H_
#define NATIVE_H_

#include <vmobjects/VMClass.h>

#include <pthread.h>
#include <stddef.h>

extern pVMClass thread_class;                                                                                                       
extern pVMClass mutex_class;                                                                                                        
extern pVMClass signal_class;

extern pthread_mutex_t _System_load_mutex;

// Globals for Thread Local Storage (current frame and thread)
extern pthread_key_t tsg_frame;
extern pthread_key_t tsg_thread;

extern bool native_threads_initialized;

typedef struct _VMSignal VMSignal, *pVMSignal;
typedef struct _VMMutex VMMutex, *pVMMutex;
typedef struct _VMThread VMThread, *pVMThread;

#endif NATIVE_H_
