#ifndef CORE_SCHEDULER_H
#define CORE_SCHEDULER_H

#include "vmobjects/VMFrame.h"

extern "C" {

//runs the passed thread
void  _Scheduler_runThread_(pVMObject object, pVMFrame frame);
//saves the thread frame to the threadlist
void  _Scheduler_registerThreadFrame_(pVMObject object, pVMFrame frame);
//removes thread frame from the thread list
void  _Scheduler_unregisterThreadFrame_(pVMObject object, pVMFrame frame);
//enters a critical section via Interpreter call
void  _Scheduler_enterCriticalSection(pVMObject object, pVMFrame frame);
//leaves a critical section via Interpreter call
void  _Scheduler_leaveCriticalSection(pVMObject object, pVMFrame frame);
//puts the entire VM to sleep for the passed period of time
void  _Scheduler_sleep_(pVMObject object, pVMFrame frame);

//run the scheduler thread - no primitive - called from interpreter
void _Scheduler_runSchedulerThread();

}

#endif /*CORE_SCHEDULER_H*/
