#ifndef CORE_IMAGE_H_
#define CORE_IMAGE_H_

/*
 *
Copyright (c) 2007 Michael Haupt, Tobias Pape
Software Architecture Group, Hasso Plattner Institute, Potsdam, Germany
http://www.hpi.uni-potsdam.de/swa/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
  */

#include <module.VMObjects>

extern "C" {

void  _Image_getSize(pVMObject object, pVMFrame frame);
void  _Image_getTimestamp(pVMObject object, pVMFrame frame);
void  _Image_getVersion(pVMObject object, pVMFrame frame);
void  _Image_getWordLength(pVMObject object, pVMFrame frame);

void  _Image_isCompressed(pVMObject object, pVMFrame frame);
void  _Image_isEncrypted(pVMObject object, pVMFrame frame);
void  _Image_isLoadable(pVMObject object, pVMFrame frame);

void __Image_init(void);
//void __Image_getCurrentVersion(pVMObject object, pVMFrame frame);

}

#endif CORE_IMAGE_H_
