#include <module.Memory>
#include <module.VM>
#include <module.Image>

#include <vmobjects/VMFrame.h>
#include <vmobjects/VMString.h>

#include <misc/debug.h>

//#include <vm/Image.h>

extern "C" {

// Hibernates the currently running image and shuts down.
void _System_hibernate_withEncryption_usingKey_(pVMObject object, pVMFrame frame) {
    pVMInteger key = (pVMInteger)SEND(frame, pop);
    int32_t i_key = SEND(key, get_embedded_integer);

    pVMInteger algorithm = (pVMInteger)SEND(frame, pop);
    int32_t i_algorithm = SEND(algorithm, get_embedded_integer);
    
    pVMString image_name = (pVMString)SEND(frame, pop);
    
    if (!Image_store(SEND(image_name, get_embedded_string), i_algorithm, i_key))
    	fprintf(stderr, "Failed.\n");
    else {
    	fprintf(stderr, "Done.\n");
        /// \bug This may be considered a bit of a rough ending ... do something ... nicer?
    	exit(0);
    }
}

// Inspects a VM image and builds a VMImage object, containing meta data. 
void _System_inspectImage_(pVMObject object, pVMFrame frame) {
    pVMString arg = (pVMString)SEND(frame, pop);
    
    pVMImage img = Image_inspect(SEND(arg, get_embedded_string));
    
    // pop system and push the result: false, or the image
    SEND(frame, pop);
    if (!img) {
    	debug_log("An error has occurred reading the image.\n");
    	SEND(frame, push, nil_object);
    }
    else 
    	SEND(frame, push, (pVMObject)img);
    
}

// Loads a VM image and runs it.
void _System_loadImage_usingKey_(pVMObject object, pVMFrame frame) {
	
	pVMInteger key = (pVMInteger)SEND(frame, pop);
	int32_t i_key = SEND(key, get_embedded_integer);
	
    pVMString image_name = (pVMString)SEND(frame, pop);
    pString s_image_name = (pString)SEND(image_name, get_embedded_string);
    
    if (!Image_load_with_name(s_image_name, i_key))
    	fprintf(stderr, "An error has occurred restoring the image.\n");
}

}
