/*
 *
Copyright (c) 2007 Michael Haupt, Tobias Pape
Software Architecture Group, Hasso Plattner Institute, Potsdam, Germany
http://www.hpi.uni-potsdam.de/swa/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

#include <stddef.h>
#include <stdbool.h>

#include <module.Memory>
#include <module.VMObjects>


/*
 * Initialize an Object
 */
void _OOObject_init(void* _self, void* param1, void* param2) {
    pOOObject self = (pOOObject)_self;
    // top level Object.
    // set the hashcode
    self->hash = (intptr_t)self;
}


//
//  Instance Methods (Starting with _OOObject_) 
//


void _OOObject_free(void* _self) {
    internal_free(_self);
}


int32_t _OOObject_object_size(void* _self) {
    return ((pOOObject)_self)->object_size;
}


int32_t _OOObject_hash_code(void* _self) {
    return ((pOOObject)_self)->hash;
}
